/*==========================================================================
 *
 *  Copyright (C) 1995-1997 Microsoft Corporation. All Rights Reserved.
 *
 *  File:	ddex4.cpp
 *  Content:	Direct Draw example program 4.	Adds functionality to 
 *		example program 3.  Creates a flipping surface and loads
 *		a bitmap image into an offscreen surface.  Uses BltFast to
 *		copy portions of the offscreen surface to the back buffer
 *		to generate an animation.  Illustrates watching return
 *		code from BltFast to prevent image tearing.  This program
 *		requires 1.2 Meg of video ram.
 *
 ***************************************************************************/

#define NAME "Astro"
#define TITLE "Astro"

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <windowsx.h>
#include <mmsystem.h>
#include <conio.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#include <ddraw.h>
#include <dinput.h>
#include <dsound.h>
#include "resource.h"
#include "ddutil.h"
#include "dati.h"
//prototipi DirectInput
void CleanupInput(void);
BOOL InitInput(HINSTANCE);
BOOL ReacquireInputDevices(void);
//Prototipi DirectSound
void InitializeSound(HWND);
void DestroySound(void);
HSNDOBJ SndObjCreate(IDirectSound *pDS, LPCTSTR lpName, int iConcurrent);
BOOL SndObjPlay(HSNDOBJ hSO, DWORD dwPlayFlags);
BOOL SndObjStop(SNDOBJ *pSO);
void SndObjDestroy(HSNDOBJ hSO);
BOOL DSGetWaveResource(HMODULE hModule, LPCTSTR lpName,
    WAVEFORMATEX **ppWaveHeader, BYTE **ppbWaveData, DWORD *pdwWaveSize);
BOOL DSFillSoundBuffer(IDirectSoundBuffer *pDSB, BYTE *pbWaveData, DWORD dwWaveSize);
BOOL DSParseWaveResource(void *pvRes, WAVEFORMATEX **ppWaveHeader, BYTE **ppbWaveData, DWORD *pdwWaveSize);
void UpdateFrame(void);
BOOL UpdateAsteroidi(void);
HRESULT restoreAll( void );
void Finisce(int);

char szBitmap[] = "nero.acc";

BYTE diKeys[256];
LPDIRECTDRAW		lpDD;		// DirectDraw object
LPDIRECTDRAWSURFACE	lpDDSPrimary;	// DirectDraw primary surface
LPDIRECTDRAWSURFACE	lpDDSBack;	// DirectDraw back surface
LPDIRECTDRAWSURFACE	lpDDSOne;	// Offscreen surface 1
//LPDIRECTDRAWSURFACE	lpDDSCielo;	// Offscreen surface 1
LPDIRECTDRAWPALETTE	lpDDPal;	// DirectDraw palette
HWND		hwnd;
LPDIRECTINPUT			lpdi;				// DirectInput interface
LPDIRECTINPUTDEVICE      lpdiKeyboard;           // keyboard device interface
BOOL						fKeybdAcquired;		// has the keyboard been acquired?
BOOL			bActive;	// is application active?

//sound
BOOL                    bSoundEnabled = FALSE;
BOOL                    bWantSound = TRUE;  //global hack to turn off sound

LPDIRECTSOUND           lpDS;

HSNDOBJ                 hsoMotore         = NULL;
HSNDOBJ                 hsoEsplosione     = NULL;
HSNDOBJ                 hsoEsploNave      = NULL;
HSNDOBJ                 hsoSparaNave      = NULL;
HSNDOBJ                 hsoSparaAlieno    = NULL;
HSNDOBJ                 hsoStella         = NULL;
HSNDOBJ                 hsoYea            = NULL;



void scrivi(void)
{
	HDC hdc;
    static BYTE c=0;
	static BYTE dir=0;
        lpDDSBack->GetDC(&hdc);
	    SetBkColor( hdc, RGB( 255, 255, 255 ) );
		SetTextColor( hdc, RGB( 0, 0, 255 ) );
		
			itoa(punti,szScritta,10);
		    TextOut( hdc, 67, 459, szScritta, lstrlen(szScritta) );
		
            itoa(livello+1,szScritta,10);
			TextOut( hdc, 258, 459, szScritta, lstrlen(szScritta) );
		
			itoa(navi,szScritta,10);
		    TextOut( hdc, 433, 459, szScritta, lstrlen(szScritta) );
		    
			itoa(super,szScritta,10);
		    TextOut( hdc, 590, 459, szScritta, lstrlen(szScritta) );
	        
			switch(dir)
			{
			case 0:
			    if(c++==256)dir=1;
				break;
			case 1:
				if(c--==0)dir=0;
				break;
			}
				           	   	
			SetTextColor( hdc, RGB( c, 0, 255 ) );
				TextOut( hdc, 340, 459, "Hrino", 5 );
			
			lpDDSBack->ReleaseDC(hdc);

}
/*
 * restoreAll
 *
 * restore all lost objects
 */
HRESULT restoreAll( void )
{
    HRESULT	ddrval;

    ddrval = lpDDSPrimary->Restore();
    if( ddrval == DD_OK )
    {
	ddrval = lpDDSOne->Restore();
	if( ddrval == DD_OK )
	{
            DDReLoadBitmap(lpDDSOne, szBitmap);
	}
    }
    return ddrval;

} /* restoreAll */

BOOL AggiornaSuperficie(ULONG x,ULONG y,IDirectDrawSurface* lpSurface,RECT Rect,ULONG flag)
{
HRESULT		ddrval;
while(1)
			
	{
			ddrval = lpDDSBack->BltFast(x ,y , lpSurface,
                                 &Rect, flag );
	        if( ddrval == DD_OK )
				return TRUE;
              if( ddrval == DDERR_SURFACELOST )
			  {
	           ddrval = restoreAll();
	            if( ddrval != DD_OK )
	    
		        return FALSE;
	    
			  }
	        if( ddrval != DDERR_WASSTILLDRAWING )
	
	       return FALSE;
   }		 

}


BOOL UpdateNave(void)
{
 RECT		    rcRect;


        rcRect.left   = 1+CurrentFrame*47+verso;
        rcRect.top    = 743;
        rcRect.right  = 47+CurrentFrame*47+verso;
        rcRect.bottom = 785;
return AggiornaSuperficie(xpos,ypos,lpDDSOne,rcRect,DDBLTFAST_SRCCOLORKEY);
		
}


BOOL UpdateNaveAlien()
{
 RECT		    rcRect;

int i;
 
   if(naxpos-5>10)naxpos-=5;  
	  else {
		  		  NaveAliena=FALSE;
				  return TRUE;
	  }
	  if(naxpos<(pos*550)/maxalien&&naxpos>200)
  {
	     i=0;
		  while(alieni[i++].attivo==TRUE&&i<20){}
		  if(--i<19)
		  {	  
  			  alieni[i].attivo=TRUE;
			  alieni[i].axpos=naxpos;
			  alieni[i].aypos=naypos+20;
			  alieni[i].direzione=1;
			 

		  }
 if(pos-1>1)pos--; 
	}
	    rcRect.left   = 37;
        rcRect.top    = 483+47*CurrentFrame;
        rcRect.right  = 125;
        rcRect.bottom = 530+47*CurrentFrame;
return AggiornaSuperficie(naxpos,naypos,lpDDSOne,rcRect,DDBLTFAST_SRCCOLORKEY);       

}



bool UpdateSuperNaveAlien()
{
 RECT		    rcRect;

 int i;
int mossa;
        
	    rcRect.left   = 3+212*CurrentFrame;
        rcRect.top    = 649;
        rcRect.right  = 214+212*CurrentFrame;
        rcRect.bottom = 697;
       mossa=0;
		for(i=0;i<20;i++)
	   {
	   if(missili[i].attivo==TRUE)
	   {   
		   if(((missili[i].mxpos>saxpos&&missili[i].mxpos<saxpos+97)
		      ||(missili[i].mxpos+5>saxpos&&missili[i].mxpos+5<saxpos+97))
		      ||((missili[i].mxpos>saxpos+120&&missili[i].mxpos<saxpos+212)
		      ||(missili[i].mxpos+5>saxpos+120&&missili[i].mxpos+5<saxpos+212)))
		   
		   switch(direzione)
		   {
			 case 0:
			   if(saxpos+228<638)saxpos+=8;
			   else direzione=1;
			   break;
			   case 1:
				  if(saxpos-8>1)saxpos-=8;
				  else direzione=0; 
			   break;
		   }
	   
	   
		   mossa=1;
	   }
	  }
	if(mossa==0) 
	    if(xpos-20>0&&xpos+214<638)  saxpos=xpos-20;
		else 
			if(xpos+214<638)saxpos=xpos;
	         else saxpos=424;   
if(!AggiornaSuperficie(saxpos,saypos,lpDDSOne,rcRect,DDBLTFAST_SRCCOLORKEY))return FALSE;	   
		
if(missilialieni[20].attivo==FALSE)
{
	missilialieni[20].attivo=TRUE;
	missilialieni[20].mxpos=saxpos+57;
	missilialieni[20].mypos=saypos+52;
}

if(missilialieni[21].attivo==FALSE)
{
	missilialieni[21].attivo=TRUE;
	missilialieni[21].mxpos=saxpos+158;
	missilialieni[21].mypos=saypos+52;
}

return TRUE;
}



void navecolpita(void)
{
	
  esplosioni[19].attivo=TRUE;
  esplosioni[19].expos=xpos+5;
  esplosioni[19].eypos=ypos+5;
  esplosioni[19].frame=0;
SndObjPlay(hsoEsploNave, NULL);
Nave=FALSE;
TickNave=GetTickCount();
if(--navi==0)
  FineGioco=TRUE;
}




void SuperNaveAlienaColpita(void)
{
	static int count=10;
	
  esplosioni[19].attivo=TRUE;
  esplosioni[19].expos=saxpos+100;
  esplosioni[19].eypos=naypos+20;
  esplosioni[19].frame=0;
  SndObjPlay(hsoEsploNave, NULL);
if(count-1>0)count--; 

else 
{
SuperNaveAliena=FALSE;
FineGioco=TRUE;
}
}




void NaveAlienaColpita(void)
{
	static int count=2;
	
  esplosioni[19].attivo=TRUE;
  esplosioni[19].expos=naxpos+5;
  esplosioni[19].eypos=naypos+5;
  esplosioni[19].frame=0;
  SndObjPlay(hsoEsploNave, NULL);
if(count-1>0)count--; 

else 
{

	
	cambiolivello=TRUE;
	if(livello+1<7){
		livello++;
      
	    count=2;
        
		}

}
NaveAliena=FALSE;

}


void AlienoColpito(int razzo)
{
int i;
	i=0;
					while(esplosioni[i++].attivo==TRUE&&i<19){};
					if(--i<19)
					{
					  esplosioni[i].attivo=TRUE;
					  esplosioni[i].expos=alieni[razzo].axpos;
					  esplosioni[i].eypos=alieni[razzo].aypos;
					  esplosioni[i].frame=0;
					}
}

void AsteroideColpito(int razzo)
{
int i;
	i=0;
					while(esplosioni[i++].attivo==TRUE&&i<19){};
					if(--i<19)
					{
					  esplosioni[i].attivo=TRUE;
					  esplosioni[i].expos=asteroidi[razzo].mxpos;
					  esplosioni[i].eypos=asteroidi[razzo].mypos;
					  esplosioni[i].frame=0;
					}
}


void MissileColpito(int razzo)
{
int i;
	i=0;
					while(esplosioni[i++].attivo==TRUE&&i<19){};
					if(--i<19)
					{
					  esplosioni[i].attivo=TRUE;
					  esplosioni[i].expos=missilialieni[razzo].mxpos;
					  esplosioni[i].eypos=missilialieni[razzo].mypos;
					  esplosioni[i].frame=0;
					}
}



BOOL UpdateMissili(void)
{
 RECT		    rcRect;
 
 int i,j;
  
	  
        rcRect.left   = 4+6*CurrentFrame;
        rcRect.top    = 622;
        rcRect.right  = 10+6*CurrentFrame;
        rcRect.bottom = 649;
for(i=0;i<20;i++)
{
 if(missili[i].attivo==TRUE)
 {
   
	 
if(AggiornaSuperficie(missili[i].mxpos, missili[i].mypos,lpDDSOne,rcRect,DDBLTFAST_SRCCOLORKEY)==FALSE)return FALSE;
	 
	 
	 
	               missili[i].mypos-=5;	

		 if(missili[i].mypos<1)
		 {missili[i].attivo=FALSE; return TRUE;}


if(SuperNaveAliena)
if(missili[i].mypos<saypos+47&&missili[i].mypos>saypos+40)
if(missili[i].mxpos>=saxpos+97&&missili[i].mxpos<=saxpos+120||
   missili[i].mxpos+7>=saxpos+97&&missili[i].mxpos+7<=saxpos+120)
{
   SuperNaveAlienaColpita();
   missili[i].attivo=FALSE;
}

//colpisce un asteroide
for(j=0;j<5;j++)
 {
    if(asteroidi[j].attivo==TRUE)
	 if(missili[i].mypos<=asteroidi[j].mypos+40&&missili[i].mxpos>=asteroidi[j].mxpos
	 &&missili[i].mxpos<=asteroidi[j].mxpos+39)
 {
	 AsteroideColpito(j);
	 SndObjPlay(hsoEsplosione, NULL);
	 missili[i].attivo=FALSE;
     
 }
}

//colpisce un altro missile o un alieno?
for(j=0;j<22;j++)
 {
    if(missilialieni[j].attivo==TRUE)
	 if(missili[i].mypos<=missilialieni[j].mypos+20&&missili[i].mxpos>=missilialieni[j].mxpos
	 &&missili[i].mxpos<=missilialieni[j].mxpos+8)
 {
	 MissileColpito(j);
	 SndObjPlay(hsoEsplosione, NULL);
	 punti+=10;
     missili[i].attivo=FALSE;
     missilialieni[j].attivo=FALSE;
 }
 
if(alieni[j].attivo==TRUE)
	 if(missili[i].mypos<=alieni[j].aypos+22&&missili[i].mxpos>=alieni[j].axpos
	 &&missili[i].mxpos<=alieni[j].axpos+43)
 {
	 AlienoColpito(j);
	 SndObjPlay(hsoEsplosione, NULL);
	 punti+=100;
     missili[i].attivo=FALSE;
     alieni[j].attivo=FALSE;
 }
}//fine for missili o alieni				   
				   
//colpisce nave aliena?
if(NaveAliena==TRUE)
if(missili[i].mypos<=naypos+50&&missili[i].mxpos>=naxpos+6
	 &&missili[i].mxpos<=naxpos+83)
{
	
    punti+=1000;
    missili[i].attivo=FALSE;
   NaveAlienaColpita();
} 
}

    
}
return TRUE;
}


BOOL UpdateAsteroidi(void)
{
 RECT		    rcRect;


 int i;
  	    rcRect.left   = 424+42*FrameAsteroidi;
        rcRect.top    = 745;
        rcRect.right  = 465+42*FrameAsteroidi;
        rcRect.bottom = 783; 

for(i=0;i<5;i++)
{
 if(asteroidi[i].attivo==TRUE)
 {

  if(AggiornaSuperficie(asteroidi[i].mxpos, asteroidi[i].mypos,lpDDSOne,rcRect,DDBLTFAST_SRCCOLORKEY)==FALSE)return FALSE;
           
     asteroidi[i].mypos+=2;
	 
     if(asteroidi[i].mypos+39>=450)asteroidi[i].attivo=FALSE;
	 if(asteroidi[i].mypos+39>ypos &&asteroidi[i].mypos+39<ypos+42 )
	 {   if(Nave)
		 if(asteroidi[i].mxpos>xpos+destra&&asteroidi[i].mxpos<xpos+45-sinistra
			 ||asteroidi[i].mxpos+40>xpos+destra&&asteroidi[i].mxpos+40<xpos+45-sinistra)
		 { 
			 
			 navecolpita();
			 		 
              asteroidi[i].attivo=FALSE;
	 
		 }
	 }
	
	}

}
return TRUE;
    
}





bool UpdateMissiliAlieni(void)
{
 RECT		    rcRect;
 

 int i;
  	  
        rcRect.left   = 23+livello*8;
        rcRect.top    = 624;
        rcRect.right  = 31+livello*8;
        rcRect.bottom = 648;
for(i=0;i<20;i++)
{
 if(missilialieni[i].attivo==TRUE)
 {
   if(AggiornaSuperficie(missilialieni[i].mxpos, missilialieni[i].mypos,lpDDSOne,rcRect,DDBLTFAST_SRCCOLORKEY)==FALSE)return FALSE;
                
     if(livello<2)       
     missilialieni[i].mypos+=2;
	 else
        missilialieni[i].mypos+=livello;
     if(missilialieni[i].mypos+22>=450)missilialieni[i].attivo=FALSE;
	 if(missilialieni[i].mypos+11>ypos &&missilialieni[i].mypos+11<ypos+42 )
	 {   if(Nave)
		 if(missilialieni[i].mxpos>xpos+destra&&missilialieni[i].mxpos<xpos+45-sinistra
			 ||missilialieni[i].mxpos+7>xpos+destra&&missilialieni[i].mxpos+7<xpos+45-sinistra)
		 { 
			 
			 navecolpita();
			 		 
              missilialieni[i].attivo=FALSE;
	 
		 }
	 
	 }
	 
 
 }

    
}
return TRUE;
}




bool UpdateSuperMissiliAlieni(void)
{
 RECT		    rcRect;

 

 int i;
  	  
        rcRect.left   = 609;
        rcRect.top    = 584;
        rcRect.right  = 621;
        rcRect.bottom = 621;
for(i=20;i<22;i++)
{
 if(missilialieni[i].attivo==TRUE)
 {
   if(AggiornaSuperficie(missilialieni[i].mxpos, missilialieni[i].mypos,lpDDSOne,rcRect,DDBLTFAST_SRCCOLORKEY)==FALSE)return FALSE;
       
     
     missilialieni[i].mypos+=3;
	 
     if(missilialieni[i].mypos+35>=450)missilialieni[i].attivo=FALSE;
	 if(missilialieni[i].mypos+20>ypos &&missilialieni[i].mypos+20<ypos+42 )
	 {   if(Nave)
		 if(missilialieni[i].mxpos>xpos+destra&&missilialieni[i].mxpos<xpos+45-sinistra
			 ||missilialieni[i].mxpos+10>xpos+destra&&missilialieni[i].mxpos+10<xpos+45-sinistra)
		 { 
			 
			 navecolpita();
			 		 
              missilialieni[i].attivo=FALSE;
	 
		 }
	 }
 }

    
}
return TRUE;
}




bool UpdateStella(void)
{
 RECT		    rcRect;
 
 


  	  
        rcRect.left   = 0+FrameStella*36;
        rcRect.top    = 700;
        rcRect.right  = 36+FrameStella*36;
        rcRect.bottom = 736;

 {
   if(AggiornaSuperficie(sxpos, sypos,lpDDSOne,rcRect,DDBLTFAST_SRCCOLORKEY)==FALSE)return FALSE;
   
            
     sypos+=1;	
     if(sypos+39>ypos)
	 {   if(Nave)
		 if((sxpos>xpos&&sxpos<xpos+50)||(sxpos+35>xpos&&sxpos+35<xpos+50))
		 {navi++;
		  SndObjPlay(hsoStella, NULL);
		 Stella=FALSE;
		 }	 		 
      if(sypos>428)
		 Stella=FALSE;
	 }
	 
 }

    

return TRUE;
}



bool UpdateExplo(void)
{
 RECT		    rcRect;

 
static int delay=70;
 int i,tickcount;
  tickcount=GetTickCount();   
  if(tickcount-TickExplo>delay)
  {
	  
	  for(i=0;i<19;i++)
	  {
		  if(esplosioni[i].attivo==TRUE)
          esplosioni[i].frame=esplosioni[i].frame+64;

	  if(esplosioni[i].frame>446)
	  {
		  esplosioni[i].frame=0;
	      esplosioni[i].attivo=FALSE;
	  }
	  }
  TickExplo=tickcount;
  }
      
for(i=0;i<19;i++)
	{
	if(esplosioni[i].attivo==TRUE)
		{
        rcRect.left   = 0+esplosioni[i].frame;
        rcRect.top    = 790;
        rcRect.right  = 63+esplosioni[i].frame;
        rcRect.bottom = 849;
		
		if(!AggiornaSuperficie(esplosioni[i].expos,esplosioni[i].eypos,lpDDSOne,rcRect,DDBLTFAST_SRCCOLORKEY))return FALSE;
		            

	}
}
return TRUE;
}


BOOL UpdateExploNave(void)
{
 RECT		    rcRect;

 
static int delay=120,lastickcount=0;;
 int tickcount;
  tickcount=GetTickCount();   
  if(tickcount-lastickcount>delay)
	{
	 esplosioni[19].frame=esplosioni[19].frame+64;

	  if(esplosioni[19].frame>446)
		{
		  esplosioni[19].frame=0;
	  
          esplosioni[19].attivo=FALSE; 
		}
		lastickcount=tickcount;
	}
	 
	  
	if(esplosioni[19].attivo==TRUE)
	{        
	    rcRect.left   = 0+esplosioni[19].frame;
        rcRect.top    = 790;
        rcRect.right  = 63+esplosioni[19].frame;
        rcRect.bottom = 849;
if(!AggiornaSuperficie(esplosioni[19].expos,esplosioni[19].eypos,lpDDSOne,rcRect,DDBLTFAST_SRCCOLORKEY))return FALSE;		
	
}
return TRUE;
}



bool RestoreBackground(void)
{
	RECT		    rcRect;

cielo--;
if (cielo==0)cielo=453;

    rcRect.left =0;
    rcRect.top = cielo;
    rcRect.right = 639;
    rcRect.bottom = 453;
    
	if(!AggiornaSuperficie(0,0,lpDDSOne,rcRect,DDBLTFAST_SRCCOLORKEY))return FALSE;
	
		
    rcRect.left = 0;
    rcRect.top = 0;
    rcRect.right= 639;
    rcRect.bottom = cielo;
    
	if(!AggiornaSuperficie(0,453-cielo,lpDDSOne,rcRect,DDBLTFAST_SRCCOLORKEY))return FALSE;
	
	
	
	// Blit the stuff for the next frame
    rcRect.left = 0;
    rcRect.top = 453;
    rcRect.right = 639;
    rcRect.bottom = 480;
    
	if(!AggiornaSuperficie(0,453,lpDDSOne,rcRect,DDBLTFAST_SRCCOLORKEY))return FALSE;


return TRUE;
}


void SparaMissile(int alieno)
{
int i;




i=0;
	while(missilialieni[i++].attivo==TRUE&&i<20){};
	if(--i<20)
	{
	  missilialieni[i].attivo=TRUE;
	  missilialieni[i].mxpos=alieni[alieno].axpos+12;
	  missilialieni[i].mypos=alieni[alieno].aypos+24;
	}

 SndObjPlay(hsoSparaAlieno, NULL);
}


bool UpdateAlien(void)
{
	RECT		    rcRect;

    DWORD       ThisTickCount;
	div_t t;
    int i;
	    rcRect.left   = 242+livello*56;
        rcRect.top    = 487+28*CurrentFrame;
        rcRect.right  = 296+livello*56;
        rcRect.bottom = 515+28*CurrentFrame;
       
        
srand((unsigned)time(NULL) );
for(i=0;i<20;i++)
{	   
	
	if(livello==5)
	{
	rcRect.left   = 242+livello*56+alieni[i].direzione*56;
    rcRect.right  = 296+livello*56+alieni[i].direzione*56;
	}
	if(livello==2)
	{
	rcRect.left   = 242+livello*56-alieni[i].direzione*173;
    rcRect.right  = 296+livello*56-alieni[i].direzione*173;
	}
	
	if(alieni[i].attivo==TRUE)

    {
		
if(!AggiornaSuperficie(alieni[i].axpos,alieni[i].aypos,lpDDSOne,rcRect,DDBLTFAST_SRCCOLORKEY))return FALSE;		

   
switch(livello)
{   
//movimento l e 4 livello
case 0:
case 3:
	if(!NaveAliena)
    if(alieni[i].axpos-4>2)alieni[i].axpos-=4;
	else{ 
			alieni[i].axpos=550;
		    if(alieni[i].aypos+20<350)
			alieni[i].aypos+=20;
			else alieni[i].aypos=5;
	}
			break;   
//mivimento 2 e 5 livello
case 1:
case 4:
	switch(alieni[i].direzione)
			{
			case 0:
				if(alieni[i].axpos-5>6)alieni[i].axpos-=5;
				else{ 
						alieni[i].direzione=1;//alieni[i].axpos=500;
						if(alieni[i].aypos+25<350)
						alieni[i].aypos+=25;
						else alieni[i].aypos=5;
				}
						break;
			case 1:
			if(alieni[i].axpos+5<580)alieni[i].axpos+=5;
					else alieni[i].direzione=0;//alieni[i].axpos=500;
					break;
			}break;
//movimento	3 e 6 livello
	case 2:
    case 5:
		switch(alieni[i].direzione)
			{
			case 0:
				if(alieni[i].axpos-5>6)alieni[i].axpos-=5;
				else{ 
						alieni[i].direzione=1;//alieni[i].axpos=500;
						if(alieni[i].aypos+25<350)
						alieni[i].aypos+=25;
						else alieni[i].aypos=5;
				}
						break;
			case 1:
			if(alieni[i].axpos+5<580)alieni[i].axpos+=5;
					else alieni[i].direzione=0;//alieni[i].axpos=500;
					break;
			}
		
		t=div(rand(),15);
        if(t.rem==0)alieni[i].aypos=(rand()%350)+5; 
		break;


		
break;
}	
ThisTickCount=GetTickCount();

if(ThisTickCount-alieni[i].spara>alieni[i].delay)
{
SparaMissile(i);

alieni[i].spara=ThisTickCount;
}

	if(Nave)
		if(alieni[i].aypos+26>ypos&&alieni[i].aypos+26<ypos+52)
		 if(alieni[i].axpos>xpos&&alieni[i].axpos<xpos+58||
			 alieni[i].axpos+51>xpos&&alieni[i].axpos+51<xpos+58)
		 {
			 navecolpita();
			 		 
            alieni[i].attivo=FALSE;
		 }
	}



}
		
		
		
		
return TRUE;
}




void CambioLivello(void)
{
RECT		    rcRect;
HRESULT         ddrval;    
   
	HDC hdc;
    
	
          
	    rcRect.left   = 240;
        rcRect.top    = 580;
        rcRect.right  = 588;
        rcRect.bottom = 631;
    

   
while(1)
			
	{
			ddrval = lpDDSPrimary->BltFast(150 ,200 , lpDDSOne,
                                 &rcRect, DDBLTFAST_SRCCOLORKEY);
	        if( ddrval == DD_OK )
				break;
              if( ddrval == DDERR_SURFACELOST )
			  {
	           ddrval = restoreAll();
	            if( ddrval != DD_OK )
	    
		        return ;
	    
			  }
	        if( ddrval != DDERR_WASSTILLDRAWING )
	
	       return ;
   }


	
        lpDDSPrimary->GetDC(&hdc);
	    SetBkColor( hdc, RGB( 128, 64, 0 ) );
		SetTextColor( hdc, RGB( 255, 255, 255 ) );
        TextOut(hdc,174,220,"Livello Completato Premi Invio Per Continuare",45);
        lpDDSPrimary->ReleaseDC(hdc);
		SndObjPlay(hsoYea, NULL);
        super+=10;
		if(livello ==3 || livello==4 || livello==5 )aster=TRUE;
		if(livello==6)SuperNaveAliena=TRUE;

}

void Finisce(int modo)
{
RECT		    rcRect;
HRESULT         ddrval;    
	HDC hdc;
             
	    rcRect.left   = 240;
        rcRect.top    = 580;
        rcRect.right  = 588;
        rcRect.bottom = 631;
    
    
	while(1)
			
	{
			ddrval = lpDDSPrimary->BltFast(150 ,200 , lpDDSOne,
                                 &rcRect, DDBLTFAST_SRCCOLORKEY);
	        if( ddrval == DD_OK )
				break;
              if( ddrval == DDERR_SURFACELOST )
			  {
	           ddrval = restoreAll();
	            if( ddrval != DD_OK )
	    
		        return ;
	    
			  }
	        if( ddrval != DDERR_WASSTILLDRAWING )
	
	       return ;
   }
   		 
        lpDDSPrimary->GetDC(&hdc);
	    SetBkColor( hdc, RGB( 128, 64, 0 ) );
		SetTextColor( hdc, RGB( 255, 255, 255 ) );
        if(modo==1)
		TextOut(hdc,194,220,"Premi S per ricominciare o Esc per uscire",41);
        else
        TextOut(hdc,174,220,"Fine Gioco S per ricominciare o Esc per uscire",46);
		lpDDSPrimary->ReleaseDC(hdc);

}

/*
 * updateFrame
 * 
 * Decide what needs to be blitted next, wait for flip to complete,
 * then flip the buffers.
 */
void UpdateFrame( void )
{
    
    
    DWORD		thisTickCount;
	static DWORD	lastTickCountRat = 0;
    static DWORD	lastTickCount = 0;
    static DWORD	lastTickCountAlien = 0;
	static DWORD    LastTickCountAster=0;
	static DWORD    TickNuovo=0;
	DWORD		delay = 50;
    DWORD       rat=500;
    DWORD       Adelay=10000;
    int i;
HRESULT ddrval;
   div_t t;  
 // preleva il tempo corrente
    thisTickCount = GetTickCount();   

	if(aster==TRUE)
	{
		if(thisTickCount - LastTickCountAster > 100)
		{
          if(++FrameAsteroidi==4)FrameAsteroidi=0;
		   LastTickCountAster=thisTickCount;
		}
		if(	thisTickCount - TickNuovo > 800)
		{i=0;
			while(asteroidi[i++].attivo==TRUE&&i<5){};
	          if(--i<5)
			  {
	           asteroidi[i].attivo=TRUE;
		srand((unsigned)time(NULL) );
		t=div(rand(),10);		
		asteroidi[i].mxpos=t.rem*50;
		        
				asteroidi[i].attivo=TRUE;
				asteroidi[i].mypos=0 ;
			  TickNuovo=thisTickCount;
			  }
		}
   }

    
     
    // trascorso il tempo per nuovo missile
	if(thisTickCount - lastTickCountRat > rat)
	{
		spara=TRUE;
		
		lastTickCountRat = thisTickCount;
	 }
	if(livello!=6)
	if(thisTickCount - lastTickCountAlien > Adelay)
	{
		srand((unsigned)time(NULL) );
		t=div(rand(),3);
        if(t.rem==0)Stella=TRUE;
		NaveAliena=TRUE;
		t=div(rand(),600);
		sxpos=t.rem;
		sypos=60;
		lastTickCountAlien = thisTickCount;
	if(maxalien+1<9)maxalien++;
		naxpos=600; 
	pos=maxalien;
	}
	// trascorso il tempo per l'animazione navicella
	if(thisTickCount - lastTickCount > delay)
	{
	    // Move to next frame;
		
	    lastTickCount = thisTickCount;
	    CurrentFrame++;
	    if(CurrentFrame > 2)CurrentFrame = 0;
	   FrameStella++;
		if(FrameStella>15)FrameStella=0;    
	    
	}
    
    
 
	
	if(!RestoreBackground())return;
    if(!cambiolivello&&!FineGioco)
	{
	if(Nave==TRUE)
		if(!UpdateNave())return;
	if(Stella==TRUE)
      if(!UpdateStella())return;
	if(aster==TRUE)
    if(!UpdateAsteroidi())return;
	if(SuperNaveAliena)
		if(!UpdateSuperNaveAlien())return; 
	if(!UpdateMissili())return;
	if(!UpdateMissiliAlieni())return;
	if(!UpdateAlien())return;
	if(!UpdateExplo())return;
    if(NaveAliena)
	if(!UpdateNaveAlien())return;
    
	if(missilialieni[20].attivo==TRUE||missilialieni[21].attivo==TRUE)
        if(!UpdateSuperMissiliAlieni())return;
	
	}
	
	
	if(esplosioni[19].attivo==TRUE)
		if(!UpdateExploNave())return;
	scrivi(); 
	       
    // Flip the surfaces
   while(1)
   {
	ddrval = lpDDSPrimary->Flip( NULL, 0 );
	
     if( ddrval == DD_OK )break;;
       if( ddrval == DDERR_SURFACELOST )
	   {
	    ddrval = restoreAll();
	    if( ddrval != DD_OK )
	    
		  return; 
	   }
	   
	if( ddrval != DDERR_WASSTILLDRAWING )
	
	    return;
   }

if(cambiolivello&&esplosioni[19].attivo==FALSE)
{
	SndObjStop(hsoMotore);
	CambioLivello();
	for(i=0;i<20;i++)
		{alieni[i].attivo=FALSE;
		 missilialieni[i].attivo=FALSE;
		}
	do{
     
	lpdiKeyboard->GetDeviceState(256,&diKeys);
	}	while(!(diKeys[DIK_RETURN]&0x80));
    SndObjPlay(hsoMotore, DSBPLAY_LOOPING);
	cambiolivello=FALSE;
}
if(FineGioco)
{
SndObjStop(hsoMotore);
if(navi==0)	
Finisce(1);
else Finisce(0);
	do{
     
	lpdiKeyboard->GetDeviceState(256,&diKeys);
	}	while(!(diKeys[DIK_S]&0x80)&&!(diKeys[DIK_ESCAPE]&0x80));
        if(diKeys[DIK_S]&0x80)
		{
		SndObjPlay(hsoMotore, DSBPLAY_LOOPING);
		FineGioco=FALSE;
		if(navi==0)
		{
		navi=5,punti=0;
        maxalien=5;
		aster=FALSE;
        pos=5;
		}
		livello=0;
		SuperNaveAliena=FALSE;
		for(i=0;i<20;i++)
		{alieni[i].attivo=FALSE;
		 missilialieni[i].attivo=FALSE;
		
		}
		}
          
}
return;
} /* updateFrame */


/*
 * finiObjects
 *
 * finished with all objects we use; release them
 */
static void finiObjects( void )
{
    if( lpDD != NULL )
    {
	if( lpDDSPrimary != NULL )
	{
	    lpDDSPrimary->Release();
	    lpDDSPrimary = NULL;
	}
	if( lpDDSOne != NULL )
	{
	    lpDDSOne->Release();
	    lpDDSOne = NULL;
	}
	if( lpDDPal != NULL )
	{
	    lpDDPal->Release();
	    lpDDPal = NULL;
	}
	lpDD->Release();
	lpDD = NULL;
    }
} /* finiObjects */

long FAR PASCAL WindowProc( HWND hWnd, UINT message, 
			    WPARAM wParam, LPARAM lParam )
{
    switch( message )
    {
    case WM_ACTIVATEAPP:
    	bActive = wParam;
        InitializeSound(hWnd);
	break;

    case WM_SETCURSOR:
        SetCursor(NULL);
        return TRUE;

    case WM_CREATE:
	break;

    case WM_KEYDOWN:
	switch( wParam )
	{
	case VK_ESCAPE:
        
            PostMessage(hWnd, WM_CLOSE, 0, 0);
	    
			break;
	
		

	}
	break;

    case WM_DESTROY:
    	finiObjects();
		CleanupInput();
		DestroySound();
	PostQuitMessage( 0 );
	break;
    }

    return DefWindowProc(hWnd, message, wParam, lParam);

} /* WindowProc */

/*
 * This function is called if the initialization function fails
 */
BOOL initFail( HWND hwnd )
{
    finiObjects();
    MessageBox( hwnd, "DirectDraw Init FAILED", TITLE, MB_OK );
    DestroyWindow( hwnd );
    return FALSE;

} /* initFail */


void Splash(void)
 {
HRESULT ddrval;
HBITMAP hbm;
 // splash 
	
	lpDDPal = DDLoadPalette(lpDD, "asteroidi256.acc");
	 if (lpDDPal)
        lpDDSPrimary->SetPalette(lpDDPal);
   
	 hbm = (HBITMAP)LoadImage( GetModuleHandle( NULL ), "asteroidi256.acc", IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION|LR_LOADFROMFILE );
    if ( NULL == hbm )
      return;

    // if the surface is lost, DDCopyBitmap will fail and the surface will
    // be restored in FlipScreen.
    ddrval = DDCopyBitmap( lpDDSBack, hbm, 0, 0, 0, 0 );

    DeleteObject( hbm );

   while(1)
   {
	ddrval = lpDDSPrimary->Flip( NULL, 0 );
	
     if( ddrval == DD_OK )break;;
       if( ddrval == DDERR_SURFACELOST )
	   {
	    ddrval = restoreAll();
	    if( ddrval != DD_OK )
	    
		  return ;
	   }
	   
	if( ddrval != DDERR_WASSTILLDRAWING )
	
	   return ;
   }
do
{
lpdiKeyboard->GetDeviceState(256,&diKeys);
}while(!(diKeys[DIK_RETURN]&0x80)&&!(diKeys[DIK_ESCAPE]&0x80)&&
	   !(diKeys[DIK_1]&0x80)&&!(diKeys[DIK_2]&0x80)&&
	   !(diKeys[DIK_3]&0x80)&&!(diKeys[DIK_4]&0x80)&&
	   !(diKeys[DIK_5]&0x80)&&!(diKeys[DIK_6]&0x80));	
	
    if(diKeys[DIK_2]&0x80)livello=1;
	if(diKeys[DIK_3]&0x80)livello=2;
	if(diKeys[DIK_4]&0x80)livello=3;
	if(diKeys[DIK_5]&0x80)livello=4;
	if(diKeys[DIK_6]&0x80)livello=5;
    if(livello==3||livello==4||livello==5)aster=TRUE;
	lpDDPal = DDLoadPalette(lpDD, szBitmap);
	 if (lpDDPal)
        lpDDSPrimary->SetPalette(lpDDPal);
   
	 SndObjPlay(hsoMotore, DSBPLAY_LOOPING);  	
	
	//fine splash
 
 }
  
  
  
 /*
 * doInit - do work required for every instance of the application:
 *		  create the window, initialize data
 */
BOOL DoInit( HINSTANCE hInstance, int nCmdShow )
{
    
    WNDCLASS		wc;
    DDSURFACEDESC	ddsd;
    DDSCAPS		ddscaps;
    HRESULT		ddrval;
    int i;
    /*
     * set up and register window class
     */
    wc.style = CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc = WindowProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInstance;
    wc.hIcon = LoadIcon( hInstance, MAKEINTRESOURCE(IDI_ICON1) );
    wc.hCursor = LoadCursor( NULL, IDC_ARROW );
    wc.hbrBackground = GetStockBrush(BLACK_BRUSH);
    wc.lpszMenuName = NAME;
    wc.lpszClassName = NAME;
    RegisterClass( &wc );
    
    /*
     * create a window
     */
    hwnd = CreateWindowEx(
        0,
	NAME,
	TITLE,
	WS_POPUP,
	0,
	0,
        GetSystemMetrics(SM_CXSCREEN),
        GetSystemMetrics(SM_CYSCREEN),
	NULL,
	NULL,
	hInstance,
	NULL );

    if( !hwnd )
    {
	return FALSE;
    }

    ShowWindow( hwnd, nCmdShow );
    UpdateWindow( hwnd );

    /*
     * create the main DirectDraw object
     */
    ddrval = DirectDrawCreate( NULL, &lpDD, NULL );
    if( ddrval != DD_OK )
    {
	return initFail(hwnd);
    }

    // Get exclusive mode
    ddrval = lpDD->SetCooperativeLevel( hwnd, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN );
    if( ddrval != DD_OK )
    {
	return initFail(hwnd);
    }

    // Set the video mode to 640x480x8
    ddrval = lpDD->SetDisplayMode( 640, 480, 8);
    if( ddrval != DD_OK )
    {
	return initFail(hwnd);
    }

    // Create the primary surface with 1 back buffer
    ddsd.dwSize = sizeof( ddsd );
    ddsd.dwFlags = DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
    ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE |
			  DDSCAPS_FLIP |
			  DDSCAPS_COMPLEX;
    ddsd.dwBackBufferCount = 1;
    ddrval = lpDD->CreateSurface( &ddsd, &lpDDSPrimary, NULL );
    if( ddrval != DD_OK )
    {
	return initFail(hwnd);
    }

    ddscaps.dwCaps = DDSCAPS_BACKBUFFER;
    ddrval = lpDDSPrimary->GetAttachedSurface(&ddscaps, &lpDDSBack);
    if( ddrval != DD_OK )
    {
	return initFail(hwnd);
    }

    

	// create and set the palette
    lpDDPal = DDLoadPalette(lpDD, szBitmap);

    if (lpDDPal)
        lpDDSPrimary->SetPalette(lpDDPal);

    // Create the offscreen surface, by loading our bitmap.
    lpDDSOne = DDLoadBitmap(lpDD, szBitmap, 0, 0);

    if( lpDDSOne == NULL )
    {

		return initFail(hwnd);
    }
    
	
	
    DDSetColorKey(lpDDSOne, RGB(0,64,64));
    for (i=0;i<20;i++)
	{
		RitAlien+=200;
		missili[i].attivo=FALSE;
		missilialieni[i].attivo=FALSE;
        alieni[i].direzione=0;
		alieni[i].spara=0;
		alieni[i].passo=0;
		alieni[i].delay=RitAlien;
		esplosioni[i].attivo=FALSE;
		esplosioni[i].frame=0;
		if(i<10)asteroidi[i].attivo=FALSE;
			
	
	}
  
missilialieni[20].attivo=FALSE;
missilialieni[21].attivo=FALSE;

	return TRUE;
} /* doInit */


void Gioco()
{
	int i;
	DWORD LastTickCount=0;
if(Nave==TRUE)
{
	sinistra=0;
	destra=0;
	verso=0;
if(lpdiKeyboard->GetDeviceState(256,&diKeys)==DI_OK)
{   
  if(diKeys[DIK_LEFT]>=128)
	{
	sinistra=6;	
	  verso=142;
		if(xpos-2>1)xpos-=2;
	}
   
  if(diKeys[DIK_RIGHT]>=128)
	{
	  destra=6;  
	  verso=283;
		if(xpos+47<638)xpos+=2;
		
	}
    
  if(diKeys[DIK_UP]>=128)
		if(ypos>150)ypos--;
  
  if(diKeys[DIK_DOWN]>=128)
		if(ypos<400)ypos++;
      
	if(spara)
	{
		spara=FALSE;		 
	if(diKeys[DIK_SPACE]>=128)
	{
		
			i=0;
	     while(missili[i++].attivo==TRUE&&i<20){};
			if(--i<20)
			{
			  missili[i].attivo=TRUE;
			  missili[i].mxpos=xpos+26;
			  missili[i].mypos=ypos-20;
			}
		 SndObjPlay(hsoSparaNave, NULL);
		 i=0;
	     while(missili[i++].attivo==TRUE&&i<20){};
			if(--i<20)
			{
			  missili[i].attivo=TRUE;
			  missili[i].mxpos=xpos+12;
			  missili[i].mypos=ypos-20;
			}
		 SndObjPlay(hsoSparaNave, NULL);
		 
		  		}//if Spazio premuto
	
  if((diKeys[DIK_B]>=128)&&super>0 )
  {i=0;
	       super--;
			while(missili[i++].attivo==TRUE&&i<20){};
			if(--i<20)
			{
			  missili[i].attivo=TRUE;
			  missili[i].mxpos=xpos+40;
			  missili[i].mypos=ypos-4;
			}
		 SndObjPlay(hsoSparaNave, NULL);	
		  i=0;
	      while(missili[i++].attivo==TRUE&&i<20){};
			if(--i<20)
			{
			  missili[i].attivo=TRUE;
			  missili[i].mxpos=xpos+2;
			  missili[i].mypos=ypos-4;
			}
		  SndObjPlay(hsoSparaNave, NULL);	
			
		 }//if B premuto

	}//spara=true


}//lettura tastiera
	
}//nave = true
	if(Nave==FALSE)
	{
		LastTickCount=GetTickCount();
	     if(LastTickCount-TickNave>1000)
		  Nave=TRUE;
	}


}




/*

 * WinMain - initialization, message loop
 */
int PASCAL WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
			LPSTR lpCmdLine, int nCmdShow)
{
    MSG		msg;
    lpCmdLine = lpCmdLine;
    hPrevInstance = hPrevInstance;

	if( !DoInit( hInstance, nCmdShow ) )
    
	return FALSE;
    
	
	if(!InitInput(hInstance))
	{
		CleanupInput();
		return FALSE;
	}
	
    

	while( 1 )
    {
		if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
		{
			if( !GetMessage( &msg, NULL, 0, 0 ) )
			return msg.wParam;
			TranslateMessage(&msg); 
			DispatchMessage(&msg);
		}
		else if( bActive )
		{  
			if(inizio)
			{
				Splash();
			    inizio=FALSE;
			}
			Gioco();

		  UpdateFrame();
		}     
	 
	}
       
    
} /* WinMain */


/*
*
* InitInput
*
* Initialize DirectInput objects & devices
*
*/
BOOL InitInput(HINSTANCE hist)
{

   HRESULT  hRes;

	// try to create di object (DIRECTINPUT_VERSION == DX5)
	if(DirectInputCreate(hist, 0x0500, &lpdi, NULL) != DI_OK)
	{
      // creation failed, try DX3 compatibility
      if(DirectInputCreate(hist, 0x0300, &lpdi, NULL) != DI_OK)
      {
        
         return FALSE;
      }
	}


	// try to create keyboard device
        if(lpdi->CreateDevice(GUID_SysKeyboard , &lpdiKeyboard, NULL) !=DI_OK)
	{
		
		return FALSE;
	}

        // Tell DirectInput that we want to receive data in keyboard format
        if (lpdiKeyboard->SetDataFormat(&c_dfDIKeyboard) != DI_OK)
        {
        
                return FALSE;
        }

        // set cooperative level
        if(lpdiKeyboard->SetCooperativeLevel(hwnd,
                         DISCL_NONEXCLUSIVE | DISCL_FOREGROUND) != DI_OK)
	{
		
		return FALSE;
        }

	// try to acquire the keyboard
   hRes = lpdiKeyboard->Acquire();
   if(SUCCEEDED(hRes))
   {
      // keyboard was acquired
      fKeybdAcquired = TRUE;
	}
   else
   {
      // keyboard was NOT acquired
      fKeybdAcquired = FALSE;
   }

	// if we get here, all objects were created successfully
	return TRUE;	
		
}



void CleanupInput(void)
{
	if(fKeybdAcquired)
	{
		lpdiKeyboard->Unacquire();
		fKeybdAcquired = FALSE;
	}

	if(lpdiKeyboard != NULL)
		lpdiKeyboard->Release();

	if(lpdi!= NULL)
		lpdi->Release();
	
}


/*
*
* ReacquireInputDevices
*
* Reacquires DirectInput devices as needed
*
*/
BOOL ReacquireInputDevices(void)
{
	// try to acquire the keyboard
        if(lpdiKeyboard != NULL)
        {
                lpdiKeyboard->Acquire();
	     }
        else
        {
                // keyboard device has not been created.
                fKeybdAcquired = FALSE;
                return FALSE;
        }

        // if we get here, we are acquired again
        fKeybdAcquired = TRUE;
        return TRUE;
}



void InitializeSound( HWND hWnd )
{
	
    bSoundEnabled = FALSE;
    if (DirectSoundCreate(NULL, &lpDS, NULL)==DS_OK)
    {
        if (lpDS->SetCooperativeLevel(hWnd,
            DSSCL_NORMAL)==DS_OK)
        {
            hsoStella         = SndObjCreate(lpDS, "Stella",1);
			hsoYea            = SndObjCreate(lpDS, "Yea",1);
			hsoMotore         = SndObjCreate(lpDS, "Motore",1);
            hsoEsplosione     = SndObjCreate(lpDS, "Esplosione",6);
            hsoEsploNave      = SndObjCreate(lpDS, "EsploNave", 1);
            hsoSparaAlieno    = SndObjCreate(lpDS, "SparaAlieno",19);
            hsoSparaNave      = SndObjCreate(lpDS, "SparaNave",  8);
            
             bSoundEnabled = TRUE;

	     
            
               

            
        }
        else
        {
            lpDS->Release();
            lpDS = NULL;
		
        }
    }
}

void DestroySound( void )
{
	if(!bWantSound)
		return; //No work to be done
    bSoundEnabled = FALSE;
    if (lpDS)
    {
        SndObjDestroy(hsoMotore);
        hsoMotore = NULL;
        SndObjDestroy(hsoEsploNave);
        hsoEsploNave = NULL;
        SndObjDestroy(hsoEsplosione);
        hsoEsplosione = NULL;
        SndObjDestroy(hsoSparaAlieno);
        hsoSparaAlieno = NULL;
        SndObjDestroy(hsoSparaNave);
        hsoSparaNave = NULL;
        SndObjDestroy(hsoStella);
        hsoStella = NULL;
        SndObjDestroy(hsoYea);
        hsoYea = NULL;
		lpDS->Release();
        lpDS = NULL;
    }
}
//DsoundUtil
///////////////////////////////////////////////////////////////////////////////
//
// DSLoadSoundBuffer
//
///////////////////////////////////////////////////////////////////////////////

IDirectSoundBuffer *DSLoadSoundBuffer(IDirectSound *pDS, LPCTSTR lpName)
{
    IDirectSoundBuffer *pDSB = NULL;
    DSBUFFERDESC dsBD = {0};
    BYTE *pbWaveData;

    if (DSGetWaveResource(NULL, lpName, &dsBD.lpwfxFormat, &pbWaveData, &dsBD.dwBufferBytes))
    {
        dsBD.dwSize = sizeof(dsBD);
        dsBD.dwFlags = DSBCAPS_STATIC | DSBCAPS_CTRLDEFAULT | DSBCAPS_GETCURRENTPOSITION2;

        if (SUCCEEDED(IDirectSound_CreateSoundBuffer(pDS, &dsBD, &pDSB, NULL)))
        {
            if (!DSFillSoundBuffer(pDSB, pbWaveData, dsBD.dwBufferBytes))
            {
                IDirectSoundBuffer_Release(pDSB);
                pDSB = NULL;
            }
        }
        else
        {
            pDSB = NULL;
        }
    }

    return pDSB;
}

///////////////////////////////////////////////////////////////////////////////
//
// DSReloadSoundBuffer
//
///////////////////////////////////////////////////////////////////////////////

BOOL DSReloadSoundBuffer(IDirectSoundBuffer *pDSB, LPCTSTR lpName)
{
    BOOL result=FALSE;
    BYTE *pbWaveData;
    DWORD cbWaveSize;

    if (DSGetWaveResource(NULL, lpName, NULL, &pbWaveData, &cbWaveSize))
    {
        if (SUCCEEDED(IDirectSoundBuffer_Restore(pDSB)) &&
            DSFillSoundBuffer(pDSB, pbWaveData, cbWaveSize))
	{
	    result = TRUE;
        }
    }

    return result;
}

///////////////////////////////////////////////////////////////////////////////
//
// DSGetWaveResource
//
///////////////////////////////////////////////////////////////////////////////

BOOL DSGetWaveResource(HMODULE hModule, LPCTSTR lpName,
    WAVEFORMATEX **ppWaveHeader, BYTE **ppbWaveData, DWORD *pcbWaveSize)
{
    HRSRC hResInfo;
    HGLOBAL hResData;
    void *pvRes;

    if (((hResInfo = FindResource(hModule, lpName, c_szWAV)) != NULL) &&
        ((hResData = LoadResource(hModule, hResInfo)) != NULL) &&
        ((pvRes = LockResource(hResData)) != NULL) &&
        DSParseWaveResource(pvRes, ppWaveHeader, ppbWaveData, pcbWaveSize))
    {
        return TRUE;
    }

    return FALSE;
}

///////////////////////////////////////////////////////////////////////////////
// SndObj fns
///////////////////////////////////////////////////////////////////////////////

SNDOBJ *SndObjCreate(IDirectSound *pDS, LPCTSTR lpName, int iConcurrent)
{
    SNDOBJ *pSO = NULL;
    LPWAVEFORMATEX pWaveHeader;
    BYTE *pbData;
    DWORD cbData;

    if (DSGetWaveResource(NULL, lpName, &pWaveHeader, &pbData, &cbData))
    {
        if (iConcurrent < 1)
            iConcurrent = 1;

        if ((pSO = (SNDOBJ *)LocalAlloc(LPTR, sizeof(SNDOBJ) +
	    (iConcurrent-1) * sizeof(IDirectSoundBuffer *))) != NULL)
        {
            int i;

            pSO->iAlloc = iConcurrent;
            pSO->pbWaveData = pbData;
            pSO->cbWaveSize = cbData;
            pSO->Buffers[0] = DSLoadSoundBuffer(pDS, lpName);

	    for (i=1; i<pSO->iAlloc; i++)
	    {
		if (FAILED(IDirectSound_DuplicateSoundBuffer(pDS,
                    pSO->Buffers[0], &pSO->Buffers[i])))
                {
		    pSO->Buffers[i] = DSLoadSoundBuffer(pDS, lpName);
		    if (!pSO->Buffers[i]) {
			SndObjDestroy(pSO);
			pSO = NULL;
			break;
		    }
		}
            }
        }
    }

    return pSO;
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

void SndObjDestroy(SNDOBJ *pSO)
{
    if (pSO)
    {
        int i;

        for (i=0; i<pSO->iAlloc; i++)
        {
            if (pSO->Buffers[i])
            {
                IDirectSoundBuffer_Release(pSO->Buffers[i]);
                pSO->Buffers[i] = NULL;
            }
        }
        LocalFree((HANDLE)pSO);
    }
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

IDirectSoundBuffer *SndObjGetFreeBuffer(SNDOBJ *pSO)
{
    IDirectSoundBuffer *pDSB;

    if (pSO == NULL)
        return NULL;

    if (pDSB = pSO->Buffers[pSO->iCurrent])
    {
        HRESULT hres;
        DWORD dwStatus;

        hres = IDirectSoundBuffer_GetStatus(pDSB, &dwStatus);

        if (FAILED(hres))
            dwStatus = 0;

        if ((dwStatus & DSBSTATUS_PLAYING) == DSBSTATUS_PLAYING)
        {
            if (pSO->iAlloc > 1)
            {
                if (++pSO->iCurrent >= pSO->iAlloc)
                    pSO->iCurrent = 0;

                pDSB = pSO->Buffers[pSO->iCurrent];
                hres = IDirectSoundBuffer_GetStatus(pDSB, &dwStatus);

                if (SUCCEEDED(hres) && (dwStatus & DSBSTATUS_PLAYING) == DSBSTATUS_PLAYING)
                {
                    IDirectSoundBuffer_Stop(pDSB);
                    IDirectSoundBuffer_SetCurrentPosition(pDSB, 0);
                }
            }
            else
            {
                pDSB = NULL;
            }
        }

        if (pDSB && (dwStatus & DSBSTATUS_BUFFERLOST))
        {
            if (FAILED(IDirectSoundBuffer_Restore(pDSB)) ||
                !DSFillSoundBuffer(pDSB, pSO->pbWaveData, pSO->cbWaveSize))
            {
                pDSB = NULL;
            }
        }
    }

    return pDSB;
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

BOOL SndObjPlay(SNDOBJ *pSO, DWORD dwPlayFlags)
{
    BOOL result = FALSE;

    if (pSO == NULL)
        return FALSE;

    if ((!(dwPlayFlags & DSBPLAY_LOOPING) || (pSO->iAlloc == 1)))
    {
	IDirectSoundBuffer *pDSB = SndObjGetFreeBuffer(pSO);
	if (pDSB != NULL) {
	    result = SUCCEEDED(IDirectSoundBuffer_Play(pDSB, 0, 0, dwPlayFlags));
	}
    }

    return result;
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

BOOL SndObjStop(SNDOBJ *pSO)
{
    int i;

    if (pSO == NULL)
        return FALSE;

    for (i=0; i<pSO->iAlloc; i++)
    {
        IDirectSoundBuffer_Stop(pSO->Buffers[i]);
        IDirectSoundBuffer_SetCurrentPosition(pSO->Buffers[i], 0);
    }

    return TRUE;
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

BOOL DSFillSoundBuffer(IDirectSoundBuffer *pDSB, BYTE *pbWaveData, DWORD cbWaveSize)
{
    if (pDSB && pbWaveData && cbWaveSize)
    {
        LPVOID pMem1, pMem2;
        DWORD dwSize1, dwSize2;

        if (SUCCEEDED(IDirectSoundBuffer_Lock(pDSB, 0, cbWaveSize,
            &pMem1, &dwSize1, &pMem2, &dwSize2, 0)))
        {
            CopyMemory(pMem1, pbWaveData, dwSize1);

            if ( 0 != dwSize2 )
                CopyMemory(pMem2, pbWaveData+dwSize1, dwSize2);

            IDirectSoundBuffer_Unlock(pDSB, pMem1, dwSize1, pMem2, dwSize2);
            return TRUE;
        }
    }

    return FALSE;
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

BOOL DSParseWaveResource(void *pvRes, WAVEFORMATEX **ppWaveHeader, BYTE **ppbWaveData,DWORD *pcbWaveSize)
{
    DWORD *pdw;
    DWORD *pdwEnd;
    DWORD dwRiff;
    DWORD dwType;
    DWORD dwLength;

    if (ppWaveHeader)
        *ppWaveHeader = NULL;

    if (ppbWaveData)
        *ppbWaveData = NULL;

    if (pcbWaveSize)
        *pcbWaveSize = 0;

    pdw = (DWORD *)pvRes;
    dwRiff = *pdw++;
    dwLength = *pdw++;
    dwType = *pdw++;

    if (dwRiff != mmioFOURCC('R', 'I', 'F', 'F'))
        goto exit;      // not even RIFF

    if (dwType != mmioFOURCC('W', 'A', 'V', 'E'))
        goto exit;      // not a WAV

    pdwEnd = (DWORD *)((BYTE *)pdw + dwLength-4);

    while (pdw < pdwEnd)
    {
        dwType = *pdw++;
        dwLength = *pdw++;

        switch (dwType)
        {
        case mmioFOURCC('f', 'm', 't', ' '):
            if (ppWaveHeader && !*ppWaveHeader)
            {
                if (dwLength < sizeof(WAVEFORMAT))
                    goto exit;      // not a WAV

                *ppWaveHeader = (WAVEFORMATEX *)pdw;

                if ((!ppbWaveData || *ppbWaveData) &&
                    (!pcbWaveSize || *pcbWaveSize))
                {
                    return TRUE;
                }
            }
            break;

        case mmioFOURCC('d', 'a', 't', 'a'):
            if ((ppbWaveData && !*ppbWaveData) ||
                (pcbWaveSize && !*pcbWaveSize))
            {
                if (ppbWaveData)
                    *ppbWaveData = (LPBYTE)pdw;

                if (pcbWaveSize)
                    *pcbWaveSize = dwLength;

                if (!ppWaveHeader || *ppWaveHeader)
                    return TRUE;
            }
            break;
        }

        pdw = (DWORD *)((BYTE *)pdw + ((dwLength+1)&~1));
    }

exit:
    return FALSE;
}
